[BITS 32]
DMA_Floppy_Buffer	equ	7000h

DMA0_ADDRESS	equ	00h
DMA1_ADDRESS	equ	02h
DMA2_ADDRESS	equ	04h
DMA3_ADDRESS	equ	06h
DMA4_ADDRESS	equ	0C0h
DMA5_ADDRESS	equ	0C4h
DMA6_ADDRESS	equ	0C8h
DMA7_ADDRESS	equ	0CCh

DMA0_COUNT	equ	01h
DMA1_COUNT	equ	03h
DMA2_COUNT	equ	05h
DMA3_COUNT	equ	07h
DMA4_COUNT	equ	0C2h
DMA5_COUNT	equ	0C6h
DMA6_COUNT	equ	0CAh
DMA7_COUNT	equ	0CEh

DMA0_PAGE	equ	87h
DMA1_PAGE	equ	83h
DMA2_PAGE	equ	81h
DMA3_PAGE	equ	82h
DMA4_PAGE	equ	8Fh
DMA5_PAGE	equ	8Bh
DMA6_PAGE	equ	89h
DMA7_PAGE	equ	8Ah

DMA_MODE8	equ	0Bh
DMA_MODE16	equ	0D6h

DMA_MASK8	equ	0Ah
DMA_MASK16	equ	0D4h

DMA_FLIPFLOP8	equ	0Ch
DMA_FLIPFLOP16	equ	0D8h

MODE_DEMAND		equ	00000000b
MODE_SINGLE		equ	01000000b
MODE_BLOCK		equ	10000000b
MODE_CASCADE	equ	11000000b

ADDR_INC	equ	00000000b
ADDR_DEC	equ	00100000b

DMA_SINGLECYCLE	equ	00000000b
DMA_AUTOINIT	equ	00010000b

DMA_VERIFY	equ	00000000b
DMA_WRITE	equ	00000100b
DMA_READ	equ	00001000b

DMA_CHANNEL0	equ	00000000b
DMA_CHANNEL1	equ	00000001b
DMA_CHANNEL2	equ	00000010b
DMA_CHANNEL3	equ	00000011b

DMA_Setup_Read:
	push ebp
	mov ebp,esp

	cli
	call DMA_DisableChannel
	
	mov al,DMA_WRITE+MODE_SINGLE	; Read from Device and WRITE to mem
	add al,2
	out DMA_MODE8,al
	
	call DMA_SetupBuffer
	call DMA_EnableChannel
	sti
	mov esp,ebp
	pop ebp
	ret

DMA_Setup_Write:
	push ebp
	mov ebp,esp

	cli
	call DMA_DisableChannel
	
	mov al,DMA_READ+MODE_SINGLE	; READ from mem to device
	add al,2
	out DMA_MODE8,al
	
	call DMA_SetupBuffer
	call DMA_EnableChannel
	sti
	mov esp,ebp
	pop ebp
	ret

DMA_SetupBuffer:
	mov eax,DMA_Floppy_Buffer
	shr eax,16
	out DMA2_PAGE,al

	mov eax,DMA_Floppy_Buffer
	and eax,0FFFFh
	out DMA2_ADDRESS,al
	mov al,ah
	out DMA2_ADDRESS,al

	mov eax,512
	dec eax
	out DMA2_COUNT,al
	mov al,ah
	out DMA2_COUNT,al
	ret

DMA_EnableChannel:
	mov al,2
	out DMA_MASK8,al
	ret
DMA_DisableChannel:
	mov eax,2	; mask channel 2
	add eax,4
	out DMA_MASK8,al
	
	xor eax,eax
	out DMA_FLIPFLOP8,al
	ret