[BITS 32]
InitVideo:
	mov edi,0B8000h
	xor eax,eax
	mov ecx,80*25*2/4
	rep stosd
	ret
PrintPMode:
	cld
	push ecx
	push eax
	mov edi,0B8000h
	mov edx,[VideoPtr]
	add edi,edx
	mov ah,[ds:esi]	; Get text attributes
	inc esi
	strloop:
		mov al,[ds:esi]
		test al,al
		je endstr
		inc esi		; faster than lodsb
		cmp al,KEY_ENTER
		je _CR
	put:	mov word [es:edi],ax
		add dword [VideoPtr],2
;		call putc
		add edi,2
		jmp strloop
	_CR:	;call GetCursorXY
;		cmp eax,24
;		jle @cr1
;		call Scroll_Up
;		jmp @cr2			; not working
	@cr1:	call PutCR
	@cr2:	push eax
		mov eax,[VideoPtr]
		mov edi,0B8000h
		add edi,eax
		pop eax
		jmp strloop
	endstr:
	call MoveCursor
	pop eax
	pop ecx
	ret
putc:
	mov edi,0B8000h
	mov edx,[VideoPtr]
	add edi,edx
	cmp al,KEY_BACKSPACE		; backspace
	je @p_bk
	cmp al,0Dh		; enter
	je @p_cr

	mov word [edi],ax
	add dword [VideoPtr],2
	
	jmp @p_exit
@p_cr:
	call PutCR
	jmp @p_exit
@p_bk:
	call PutBkSpace
@p_exit:
	call MoveCursor
	ret

GotoXY:	; eax = row, ebx = col, pos = 2*(row*80+col)
	mov ecx,eax	; take another copy in ecx
	shl eax,6	; multiply eax by 64
	shl ecx,4	; multiply ecx by 16
	add eax,ecx	; add both together to get row * 80 as 64 +16 = 80
	add eax,ebx	; add col no.
	inc eax
	shl eax,1	; multiply by 2
	mov [VideoPtr],eax
	ret

ClearScr:
	cld
	mov edi,0B8000h
	mov al," "
	mov ah,bl
	mov ecx,80*25
	rep stosw
	endcloop:
	mov dword [VideoPtr],0
	ret

MoveCursor:
	push ax
	push dx

	mov ax,[VideoPtr]
	shr ax,1
	mov bx,ax		; save it in bx

	mov dx,03D4h
	mov al,0Fh
	out dx,al	;

	inc dx
	mov ax,bx
	out dx,al	; out 03D5h,low byte of offset

	dec dx
	mov ax,0Eh
	out dx,ax	;

	inc dx
	mov ax,bx
	xchg ah,al
	out dx,al	; out 03D5h,high byte

	pop dx
	pop ax
	ret
; Returns row in eax and column in edx
GetCursorXY:
	mov eax,[VideoPtr]
	xor edx,edx
	mov ecx,160
	div ecx
	shr edx,1
	shr eax,1
	ret

Scroll_Up:
	cld
	mov byte[0B8082h],'D'
	mov byte[0B8083h],0Dh

	mov esi,0B8000h+(80*2)
	mov edi,0B8000h
	mov ecx,(80*24*2)/4
	rep movsd

	mov edi,0B8000h+(80*24*2)
	mov eax,0E200E20h
	mov ecx,160/4
	rep stosd

	mov dword[VideoPtr],80*23*2	; put it 2 lines above
	ret
PutCR:
	push eax	; save all the regs
	push edx
	push ecx

	mov eax,[VideoPtr]; get current VGA CursorPos
	xor edx,edx		; zero edx
	mov ecx,160		; divide the cursur pos by 1600
	push ecx
	div ecx		;
	pop ecx
	sub ecx,edx		; find 160 - remainder
	add [VideoPtr],ecx; add it to current pos
	mov eax,[VideoPtr]

	call MoveCursor

	pop ecx
	pop edx
	pop eax
	ret

PutBkSpace:
	cmp dword[CursorPos],0
	je @bk_x

	dec dword[CursorPos]
	sub dword[VideoPtr],2

	mov edx,[CursorPos]
	mov byte[CmdBuffer+edx],0

	mov edi,0B8000h
	mov edx,[VideoPtr]
;	shl edx,1
	add edi,edx
	mov word[edi],0E20h

@bk_x:ret
; Gets the cursor pos in eax and sets variable
GetVGACursor:
	push ebp
	mov ebp,esp

	mov dx,03D4h
	mov al,0Eh
	out dx,al

	inc dx
	in al,dx
	mov bh,al

	dec dx	
	mov al,0Fh
	out dx,al

	inc dx
	in al,dx
	mov bl,al

	movzx eax,bx

	mov esp,ebp
	pop ebp
	ret 4

; Takes offset in form offset = (80*y)+x (dword param)
SetVGACursor:
	push ebp
	mov ebp,esp

	mov ebx,[ebp+8]

	mov dx,03D4h
	mov al,0Eh
	out dx,al

	inc dx
	mov al,bh
	out dx,al

	dec dx
	mov al,0Fh
	out dx,al

	inc dx
	mov al,bl
	out dx,al

	mov esp,ebp
	pop ebp
	ret 4

VideoPtr	dd	0